unit Unit4;

interface

uses Forms, Controls, StdCtrls, Classes, ExtCtrls, Dialogs, Windows,
     Nihongo, ShellApi;
{ Windows, Messages, SysUtils, Graphics, Dialogs }

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Panel1: TPanel;
    PaintBox1: TPaintBox;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Bevel1: TBevel;
    Label2: TLabel;
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

const
  ERR00 = 'Error initializing nihongo engine!'+#10+
          '(Font files not found?)';

implementation

{$R *.DFM}

// --------------------------------------------------------------------

procedure hHalt(_err: string);

begin
  ShowMessage(_err);
  Halt;
end;

// --------------------------------------------------------------------

procedure Draw0;

begin
  Form1.PaintBox1.Canvas.Pen.Color := clWhite;
  Form1.PaintBox1.Canvas.Brush.Color := clWhite;
  Rectangle(Form1.PaintBox1.Canvas.handle, 0, 0,
            Form1.PaintBox1.Width, Form1.PaintBox1.Height);
end;

// --------------------------------------------------------------------

procedure DrawText;

var _s : string;
    _x : longint;

begin
//  _s := jRomanji2Kana(Form1.Edit1.Text);
  Application.Title := Form1.Edit1.Text;
  _s := jGetEUCKana(Form1.Edit1.Text);

  // Draw
  Form1.PaintBox1.Canvas.Pen.Color := clWhite;
  Form1.PaintBox1.Canvas.Brush.Color := clWhite;
  _x := length(_s) shl 3;
  if _x > Form1.PaintBox1.Width
    then _x := Form1.PaintBox1.Width - _x
      else _x := 0;
  jWrite(_x, 2, 16, 16, _s, jEUC, false, true, false,
         Form1.PaintBox1.Canvas.Handle);
  Rectangle(Form1.PaintBox1.Canvas.handle, length(_s) shl 3, 0,
            Form1.PaintBox1.Width, Form1.PaintBox1.Height);
end;

// --------------------------------------------------------------------

procedure TForm1.Edit1Change(Sender: TObject);

begin
  DrawText;
end;

// --------------------------------------------------------------------

procedure TForm1.FormCreate(Sender: TObject);

begin
  // Initializa Nihongo Engine
  if jInitialize = false then hHalt(ERR00);
end;

// --------------------------------------------------------------------

procedure TForm1.FormDestroy(Sender: TObject);

begin
  jClose;
end;

// --------------------------------------------------------------------

procedure TForm1.PaintBox1Paint(Sender: TObject);

begin
  draw0;
  drawText;
end;

// --------------------------------------------------------------------

procedure DownLoadFile(_url: string);

begin
  _url := _url + #0;
  ShellExecute(Form1.handle, NIL, @_url[1], NIL, NIL, SW_SHOW);
end;

// --------------------------------------------------------------------

procedure TForm1.Button2Click(Sender: TObject);

begin
  DownLoadFile('ftp://ftp.cc.monash.edu.au/pub/nihongo/enamdict.zip');
end;

// --------------------------------------------------------------------

procedure TForm1.Button1Click(Sender: TObject);

begin
  DownLoadFile('ftp://ftp.cc.monash.edu.au/pub/nihongo/edict.zip');
end;

// --------------------------------------------------------------------

end.
