{$apptype console}
{$A-}

program DictIDX;

uses SysUtils, Filez;

const ERR00   = 'Error while opening file or file not found: ';
      ERR01   = 'File empty';
      TXT00   = 'Loading: [';
      TXT01   = ' done!';
      TXT02   = 'Invalid dictionary format.';
      TXT03   = 'Writing...';
      TXT04   = 'DictIDX Test v0.2' + #10;
      EXT00   = '.IND';
      DEFDICT = 'Edict';

var DictDATA : pointer;
    DictSIZE : longint;
    DictNAME : string;

// -------------------------------------------------------------------

procedure hHalt(_err: string);

begin
  Writeln(_err);
  Beep;
  Halt;
end;

// -------------------------------------------------------------------

procedure LoadDict(_fn: string);

var _f: file;

begin
  DictNAME := _fn;
  if fOpenBinFile(_fn, _f) = false then hHalt(ERR00 + _fn);
  DictSIZE := FileSize(_f);
  if DictSIZE = 0 then hHAlt(ERR01 + _fn);
  GetMem(DictDATA, DictSIZE);
  Write(TXT00 + _fn + ']');
  BlockRead(_f, DictDATA^, DictSIZE);
  CloseFile(_f);
  Writeln(TXT01);
end;

// -------------------------------------------------------------------

procedure UnLoadDict;

begin
  FreeMem(DictDATA, DictSIZE);
end;

// -------------------------------------------------------------------

procedure GetV(_s: string; var _v1, _v2: byte);

var _cnt: word;

begin
  _v1 := 0;
  _v2 := 0;
  if length(_s) = 0 then hHalt(TXT02);
  for _cnt := 1 to length(_s) do
    begin
      if _s[_cnt] = ' ' then
        if _v1 = 0 then
          if _cnt < 256 then _v1 := _cnt else hHalt(TXT02);
      if _s[_cnt] = ']' then
        if _v2 = 0 then
          if _cnt < 256 then _v2 := _cnt + 1 else hHalt(TXT02);
    end;
  if _v1 = 0 then hHalt(TXT02);
end;

// -------------------------------------------------------------------

procedure DoTheJob;

var _f1   : file;
    _p    : pointer;
    _cnt  : longint;
    _line : longint;
    _lcnt : longint;
    _s    : string;

    _idx : record
//             offset : longint;
             v1     : byte;
             v2     : byte;
             length : word;
           end;

begin
  // Create File(s)
  fCreateBinFile(DictNAME + EXT00, _f1);

  _s := '';
  _cnt := 0;
  _line := 0;
  _lcnt := 0;
  _p := DictDATA;

//  BlockWrite(_f1, _cnt, sizeof(_cnt)); // Write begin OffSet

  while _cnt <> DictSize do
    begin
      if byte(_p^) = 10 then // Next line
        begin
          // copy string
          dec(longint(_p), _lcnt);
          SetLength(_s, _lcnt);
          Move(_p^, _s[1], _lcnt);
          inc(longint(_p), _lcnt);

          // save idx
//          _idx.offset := _cnt - _lcnt;
          GetV(_s, _idx.v1, _idx.v2);
          _idx.length := _lcnt;
          BlockWrite(_f1, _idx, sizeof(_idx));

          // display string
//          write(_s + #10);

          // next string
          inc(_line);
          _lcnt := 0;
          if _line and $FF = $FF
            then Write(#13 + TXT03 + ' ',
                      (_cnt * 100) div DictSize, '%');
        end else inc(_lcnt);

      // incs
      inc(_cnt);
      inc(longint(_p));
    end;

  // Close File(s)
  CloseFile(_f1);

  Writeln(#13, TXT03, TXT01);
end;

// -------------------------------------------------------------------

(*
procedure DoTheJob;

var _f1   : file;
    _p    : pointer;
    _cnt  : longint;
    _line : longint;
    _lcnt : longint;
    _s    : string;

begin
  // Create File(s)
  jCreateBinFile(DictNAME + EXT00, _f1);

  _s := '';
  _cnt := 0;
  _line := 0;
  _lcnt := 0;
  _p := DictDATA;
  while _cnt <> DictSize do
    begin
      if byte(_p^) = 10 then // Next line
        begin
          // copy string
          dec(longint(_p), _lcnt);
          SetLength(_s, _lcnt);
          Move(_p^, _s[1], _lcnt);
          inc(longint(_p), _lcnt);

          // displaystring
          write(_s + #10);

          // next string
          inc(_line);
          _lcnt := 0;
        end else inc(_lcnt);

      if byte(_p^) = 10 then
        begin
          inc(_line);
          if _line and $F = $F
            then Write(#13, (_cnt * 100) div DictSize, '%');
        end;

      // incs
      inc(_cnt);
      inc(longint(_p));
    end;

  // Close File(s)
  CloseFile(_f1);
end;
*)
// -------------------------------------------------------------------

begin
  Writeln(TXT04);

  // Load dictionary
  if paramcount = 0 then LoadDict(DEFDICT) else LoadDict(paramstr(1));

  // Do the IDX;
  DoTheJob;

  // Free mem.
  UnLoadDict;
end.
